﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects.DataClasses;

namespace PhenoReports
{
    /// <summary>
    /// Clase que implementa métodos útiles para manejar Entity Framework
    /// </summary>
    static class EntityUtils
    {
        /// <summary>
        /// Crea un clon de una entidad
        /// </summary>
        /// <typeparam name="T">Tipo de entidad</typeparam>
        /// <param name="source">Entidad a clonar</param>
        /// <returns>Un clon de la entidad</returns>
        public static T Clone<T>(this T source)
        {
            var dcs = new System.Runtime.Serialization
              .DataContractSerializer(typeof(T));
            using (var ms = new System.IO.MemoryStream())
            {
                dcs.WriteObject(ms, source);
                ms.Seek(0, System.IO.SeekOrigin.Begin);
                return (T)dcs.ReadObject(ms);
            }
        }
    }
}
