﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

using System.Drawing;
using System.Drawing.Imaging;

using System.Windows.Controls;

using System.ComponentModel;

namespace PhenoReports
{
    /// <summary>
    /// Lógica de interacción para LabelWindow.xaml
    /// </summary>
    public partial class LabelWindow : Window
    {
        //Gestor de Códigos QR 
        QRCodeManager miQR;      

        public LabelWindow()
        {
            InitializeComponent();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
           }    


        //Genera fichero word con código QR
        private void button3_Click(object sender, RoutedEventArgs e)
        {            
            if (miQR != null) 
            {
                miQR.generaQRWord(wordFiletextBox.Text);
            }
        }

        private void textBox1_TextChanged(object sender, TextChangedEventArgs e)
        {

        
        }
        /// <summary>
        /// Busca paciente en el sistema
        /// </summary>
        
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            using (var context = new modelHemo.hemoEntities())
            {
                var receveurs = from re in context.RECEVEUR
                                where re.REC_NUMERO.Trim().Equals(textBox2.Text.Trim())
                                select re;

                if (receveurs.Count() >0 ){
                    nombretextBox.IsEnabled = true;
                    apellidostextBox.IsEnabled = true;
                    cptextBox.IsEnabled = true;
                    ciudadtextBox.IsEnabled = true;
                    direcciontextBox.IsEnabled = true;
                    telefonotextBox.IsEnabled = true;
                    foreach (var receveur in receveurs)
                    {
                        nombretextBox.Text = receveur.REC_PRENOM;
                        apellidostextBox.Text = receveur.REC_NOM;
                        cptextBox.Text = receveur.REC_CPOST;
                        ciudadtextBox.Text = receveur.REC_VILLE;
                        direcciontextBox.Text = receveur.REC_ADRESSE;
                        telefonotextBox.Text = receveur.REC_TELP_NO;


                        string quickResponse = "Paciente: " + nombretextBox.Text.Trim() + ", " + apellidostextBox.Text.Trim()
                   + "\nCod.Postal:" + cptextBox.Text.Trim() + "\nLocalidad:" + ciudadtextBox.Text.Trim() + "\nDireccion" + direcciontextBox.Text.Trim() + "\nTel:" + telefonotextBox.Text.Trim();
                        miQR = new QRCodeManager(quickResponse);
                        imagenQR.Source = miQR.BitmapSource;
                    }
                }
                else
                    {
                    nombretextBox.Text="";
                    apellidostextBox.Text="";
                    cptextBox.Text="";
                    ciudadtextBox.Text="";
                    direcciontextBox.Text="";
                    telefonotextBox.Text = "";
                    }
                }
             
        }


        /// <summary>
        /// Abre un cuadro de dialogo para seleccionar el fichero word donde se guardará el código QR
        /// </summary>
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = "word";
            dlg.Filter = "Fichero Word|*.doc";
            dlg.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory + "EXPORT\\";            
            dlg.ShowDialog(this);
            wordFiletextBox.Text = dlg.FileName;
        }
        /// <summary>
        /// Busca los productos de la toma de un donante
        /// </summary>

        private void buscarToma_Click(object sender, RoutedEventArgs e)
        {
            using (var context = new modelHemo.hemoEntities())
            {
                var codproducts = from p in context.STOCK
                                where p.PREL_NO.Trim().Equals(tomatextBox.Text.Trim())
                                select p;
                if (codproducts.Count() > 0)
                {
                    codProductocomboBox1.IsEnabled = true;
                    foreach (var codproduct in codproducts)
                    {
                        codProductocomboBox1.Items.Add(codproduct.PRODF_CD);

                    }
                }
                else { codProductocomboBox1.IsEnabled = false; }
               
            } 
        }
        /// <summary>
        /// Muestra el detalle del producto
        /// </summary>
        
        private void codProductocomboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Busca el detalle del producto a partir de la toma y el producto seleccionado
            using (var context2 = new modelHemo.hemoEntities()) 
            {
                string sel = codProductocomboBox1.SelectedItem.ToString();
                var products = from p in context2.STOCK
                               join prod in context2.PPROD
                               on p.PROD_CD equals prod.PROD_CD
                               where (p.PREL_NO.Trim().Equals(tomatextBox.Text.Trim()) && p.PRODF_CD.Trim().Equals(sel))

                               select new
                               {
                                   p.DONN_NUMERO,
                                   p.STK_ETAT,
                                   p.REC_NUMERO,
                                   p.STK_VOL,
                                   p.STK_DTPRODUCT,
                                   p.STK_DTPEREMP,
                                   p.STK_DTENTREE,                                   
                                   prod.PROD_LIB
                               };
                if (products.Count() > 0)
                {
                    
                    foreach (var product in products)
                    {
                        productotextBox.Text = product.PROD_LIB.Trim();
                        donantetextBox.Text = ((product.DONN_NUMERO == null) ? "" : product.DONN_NUMERO.Trim());
                        estadotextBox.Text = ((product.STK_ETAT == null) ? "" : product.STK_ETAT.Trim());
                        pacientetextBox.Text = ((product.REC_NUMERO == null) ? "" : product.REC_NUMERO.Trim());
                        volumentextBox.Text = ((product.STK_VOL == null) ? "" : product.STK_VOL.ToString().Trim());
                        producciontextBox.Text = ((product.STK_DTPRODUCT == null) ? "" : product.STK_DTPRODUCT.ToString());
                        colectatextBox.Text = ((product.STK_DTENTREE == null) ? "" : product.STK_DTENTREE.ToString());
                        caducidadtextBox.Text = ((product.STK_DTPEREMP == null) ? "" : product.STK_DTPEREMP.ToString());

                        string quickResponse = "Producto: " + codProductocomboBox1.SelectedItem.ToString().Trim() + " - " + productotextBox.Text + "\n"
                            + "Donante: " + donantetextBox.Text.Trim() + "\n" + "Estado: " + estadotextBox.Text.Trim() + "\n"
                            + "Paciente: " + pacientetextBox.Text.Trim() + "\n" + "Volumen: " + volumentextBox.Text.Trim() + "\n" +
                            "F. Colecta: " + colectatextBox.Text.Trim() + "\n" + "F.Caduc.: " + caducidadtextBox.Text.Trim();
                        miQR = new QRCodeManager(quickResponse);
                        imagenQrBolsa.Source = miQR.BitmapSource;

                    }                   

                }
                else
                {
                    
                    donantetextBox.Text="";                   
                    estadotextBox.Text="";                   
                    pacientetextBox.Text="";                    
                    volumentextBox.Text="";                  
                    producciontextBox.Text="";                  
                    colectatextBox.Text="";                   
                    caducidadtextBox.Text = "";
                } 

                
            }
        }

 

 
     

    }
}
