﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using modelHemo;
using System.ComponentModel; 
using System.Runtime.InteropServices;
using System.Data.Objects;
using System.Collections.ObjectModel;
using Word = Microsoft.Office.Interop.Word;

namespace PhenoReports
{
    /// <summary>
    /// Lógica de interacción para ListadosWindow.xaml
    /// </summary>
    public partial class ListadosWindow : Window
    {
       
        
        DataTable resultadosDT;
        modelHemo.hemoEntities hemoEntities;
        System.Data.Objects.ObjectQuery<modelHemo.SHIIG_FAMSTATS> sHIIG_FAMSTATSQuery;
        public ListadosWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            hemoEntities = new modelHemo.hemoEntities();
            // Cargar datos en SHIIG_FAMSTATS. Puede modificar este código según sea necesario.
            System.Windows.Data.CollectionViewSource sHIIG_FAMSTATSViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("sHIIG_FAMSTATSViewSource")));
            sHIIG_FAMSTATSQuery = this.GetSHIIG_FAMSTATSQuery(hemoEntities);
            sHIIG_FAMSTATSViewSource.Source = sHIIG_FAMSTATSQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);        
            

            // Cargar datos en PSITE. Puede modificar este código según sea necesario.
            System.Windows.Data.CollectionViewSource pSITEViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("pSITEViewSource")));
            System.Data.Objects.ObjectQuery<modelHemo.PSITE> pSITEQuery = this.GetPSITEQuery(hemoEntities);
            pSITEViewSource.Source = pSITEQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);
        }

        /// <summary>
        ///  Genera Txt que será el origen de datos para la combinación de correspondencia con el mismo nombre que el fichero word
        ///    que presentará y fusionará los resultados
        /// </summary>
     
        private void EtiquetasButton_Click(object sender, RoutedEventArgs e)
        {
           
            try {
                string filename = ((modelHemo.SHIIG_STATSMAILMERGE)(sHIIG_STATSMAILMERGEDataGrid.Items[0])).FILE_LOCATION.Trim().Replace(".doc", ".txt");
                ExportManager.exportToCSV(resultadosDT, filename,false);
                string listSeparator = System.Globalization.CultureInfo.CurrentCulture.TextInfo.ListSeparator;

                Word.Application wrdApp;
                Word._Document wrdDoc;
                wrdApp = new Word.Application();
                Object oMissing = System.Reflection.Missing.Value; 
                Object oFalse = false;
                Object oName = ((modelHemo.SHIIG_STATSMAILMERGE)(sHIIG_STATSMAILMERGEDataGrid.Items[0])).FILE_LOCATION.Trim();
               //Comprueva si el word de plantilla existe.
                bool nuevoDoc = !System.IO.File.Exists((string)oName);
                if (nuevoDoc)
                {
                    MessageBox.Show("Documento no existente, se creará un documento vacío enlazado a los datos.", "", MessageBoxButton.OK, MessageBoxImage.Information);
                    
                    wrdDoc = wrdApp.Documents.Add(ref oMissing, ref oMissing, ref oMissing, true);
                }
                else
                {
                    wrdDoc = wrdApp.Documents.Open(ref oName, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing,
                        ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, true, ref oMissing, ref oMissing, ref oMissing, ref oMissing);
                }
                
                wrdDoc.MailMerge.OpenDataSource(filename, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing,
                    ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing);
                wrdApp.Visible = true;
                wrdDoc.SaveAs(oName, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing,
                    ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing);
                //Ejecuta la combinación de correspondencia automáticamente si ya se ha creado préviamente el documento
                if (!nuevoDoc)
                {
                    wrdDoc.MailMerge.Execute();
                    wrdApp.PrintPreview = true;
                }


            }
            catch (Exception ex){
                MessageBox.Show(ex.Message,"Error en la creacion del fichero");
            }
            
        }


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try { 
            resultados.IsSelected = true;
            
            string consultaConParams = sQLTextBox.Text.Replace("&FI", "CONVERT(datetime,'" + FIdatePicker.Text + "',103)");
            consultaConParams = consultaConParams.Replace("&FF", "CONVERT(datetime,'" + FFdatePicker.Text + "',103)");
            consultaConParams = consultaConParams.Replace("&SI", "'" + pSITE_CDComboBox.Text + "'");
                // TODO cambiar consulta por string!!!!

            resultadosDT = QueryUtils.fillDatatableWithSql("RESULTADOS", consultaConParams);
            resultadoListado.ItemsSource = resultadosDT.DefaultView;
            resultadoListado.AutoGenerateColumns = true;

           
            if (resultadoListado.Items.Count > 0)
            {
                ExcelButton.IsEnabled = true;
                WordButton.IsEnabled = true;
                PDFbutton.IsEnabled = true;
                CSVbutton.IsEnabled = true;
                EtiquetasButton.IsEnabled = true;
                    
            }
            else 
            {
            ExcelButton.IsEnabled = false;
            WordButton.IsEnabled = false;
            PDFbutton.IsEnabled = false;
            CSVbutton.IsEnabled = false;
            EtiquetasButton.IsEnabled = false;
            }
            }
            catch (Exception ex)
            { MessageBox.Show("Error en consulta SQL!!\n"+ex.Message, "", MessageBoxButton.OK, MessageBoxImage.Error); }
        }

     
        //Abre MS Excel y copia el contenido del listado en una hoja de calculo
        private void ExcelButton_Click(object sender, RoutedEventArgs e)
        {
            try { 
            
               Microsoft.Win32.SaveFileDialog dlg =  new Microsoft.Win32.SaveFileDialog();
                dlg.DefaultExt= "xls";
                dlg.Filter ="Hoja Calculo Excel (.xls)|*.xls";
                dlg.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory + "EXPORT\\";
                dlg.ShowDialog(this);
                ExportManager.exportToExcel(resultadosDT, dlg.FileName);
            }
            catch { MessageBox.Show("Error generando fichero xls!!", "", MessageBoxButton.OK, MessageBoxImage.Error); }
        }

        private void WordButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
               
                Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
                dlg.DefaultExt = "doc";
                dlg.Filter = "Documento Ms Word 2003 (.doc)|*.doc";
                dlg.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory + "EXPORT\\";
                dlg.ShowDialog(this);
                ExportManager.exportToWord(resultadosDT, dlg.FileName);
            }
            catch { MessageBox.Show("Error generando fichero doc!!", "", MessageBoxButton.OK, MessageBoxImage.Error); 
            }
        }

        private void PDFbutton_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
                dlg.DefaultExt = "pdf";
                dlg.Filter = "Fichero PDF (.pdf)|*.pdf";
                dlg.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory + "EXPORT\\";

                dlg.ShowDialog(this);
                ExportManager.exportToPDF(resultadosDT, dlg.FileName);
            }
            catch
            {
                MessageBox.Show("Error generando fichero PDF!!", "", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void CSVbutton_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
                dlg.DefaultExt = "csv";
                dlg.Filter = "Fichero separado por comas (.csv)|*.csv";
                dlg.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory + "EXPORT\\";
                dlg.ShowDialog(this);
                ExportManager.exportToCSV(resultadosDT, dlg.FileName);

            }
            catch
            {
                MessageBox.Show("Error generando fichero csv!!", "", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        private void newListbutton2_Click(object sender, RoutedEventArgs e)
        {
            hemoEntities.SaveChanges();
        }

        private ObjectQuery<SHIIG_FAMSTATS> GetSHIIG_FAMSTATSQuery(hemoEntities hemoEntities)
        {
            // Código generado automáticamente

            System.Data.Objects.ObjectQuery<modelHemo.SHIIG_FAMSTATS> sHIIG_FAMSTATSQuery = hemoEntities.SHIIG_FAMSTATS;
            // Actualizar la consulta para incluir datos de SHIIG_STATS en SHIIG_FAMSTATS. Puede modificar este código según sea necesario.
            sHIIG_FAMSTATSQuery = sHIIG_FAMSTATSQuery.Include("SHIIG_STATS");
            // Actualizar la consulta para incluir datos de SHIIG_STATSMAILMERGE en SHIIG_FAMSTATS. Puede modificar este código según sea necesario.
            sHIIG_FAMSTATSQuery = sHIIG_FAMSTATSQuery.Include("SHIIG_STATS.SHIIG_STATSMAILMERGE");
            // Devuelve un elemento ObjectQuery.
            return sHIIG_FAMSTATSQuery;
        }

        private ObjectQuery<PSITE> GetPSITEQuery(hemoEntities hemoEntities)
        {
            // Código generado automáticamente

            System.Data.Objects.ObjectQuery<modelHemo.PSITE> pSITEQuery = hemoEntities.PSITE;
            // Devuelve un elemento ObjectQuery.
            return pSITEQuery;
        }

        private void SeleccionaFichero_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = "doc";
            dlg.Filter = "Fichero Word 2003|*.doc";
             
                dlg.InitialDirectory = ((SHIIG_STATSMAILMERGE)(sHIIG_STATSMAILMERGEDataGrid.Items[0])).FILE_LOCATION.Trim();
            
            
            dlg.ShowDialog(this);
            ((SHIIG_STATSMAILMERGE)(sHIIG_STATSMAILMERGEDataGrid.SelectedItem)).FILE_LOCATION = dlg.FileName;
        }


        
       
    }
}
