
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 04/30/2012 19:48:53
-- Generated from EDMX file: C:\Users\moises\Dropbox\UOC\Treball Final Carrera\2012\Código\PhenoReports\PhenoReports\Modelhemo.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [hemo];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------


-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[PERSONNEL]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PERSONNEL];
GO
IF OBJECT_ID(N'[dbo].[PERSROLE]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PERSROLE];
GO
IF OBJECT_ID(N'[dbo].[PSITE]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PSITE];
GO
IF OBJECT_ID(N'[dbo].[UTILISATEUR]', 'U') IS NOT NULL
    DROP TABLE [dbo].[UTILISATEUR];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'PERSONNEL'
CREATE TABLE [dbo].[PERSONNEL] (
    [PERS_CD] char(10)  NOT NULL,
    [PERS_SEXE] char(1)  NULL,
    [PERS_NOM] varchar(100)  NULL,
    [PERS_PRENOM] varchar(100)  NULL,
    [PERS_ADR1] varchar(150)  NULL,
    [PERS_ADR2] varchar(150)  NULL,
    [PERS_CPOST] char(12)  NULL,
    [PERS_VILLE] varchar(100)  NULL,
    [PERS_TEL1] char(15)  NULL,
    [PERS_TEL2] char(15)  NULL,
    [PERS_FAX] char(15)  NULL,
    [PERS_NOTE] varchar(255)  NULL,
    [PERS_LANGUE] char(1)  NULL,
    [PERS_DESACT] datetime  NULL,
    [PERS_ADR3] varchar(100)  NULL,
    [PERS_ROUTAGE] varchar(6)  NULL,
    [PPAYS_CD] varchar(4)  NULL,
    [PDEPART_CD] varchar(4)  NULL,
    [COMMURB_CD] varchar(4)  NULL,
    [REGION_CD] varchar(2)  NULL,
    [PERS_CELL] varchar(15)  NULL,
    [PERS_PAGER] varchar(15)  NULL,
    [PERS_EMAIL] varchar(200)  NULL,
    [PTITRE_CD] varchar(4)  NULL
);
GO

-- Creating table 'UTILISATEUR'
CREATE TABLE [dbo].[UTILISATEUR] (
    [UT_CODE] char(10)  NOT NULL,
    [UT_TITRE] varchar(40)  NULL,
    [UT_NOM] varchar(40)  NULL,
    [UT_PRENOM] varchar(40)  NULL,
    [UT_ACTIF] char(1)  NULL,
    [UT_DT_DESACT] datetime  NULL,
    [UT_PASSWORD] varchar(75)  NULL,
    [UT_DT_PWD] datetime  NULL,
    [UTP_CODE] char(2)  NULL,
    [UT_NB_TENTATIVE] decimal(5,0)  NULL,
    [UT_DTH_TENTATIVE] datetime  NULL,
    [UT_BLOQUE] char(1)  NULL,
    [UT_DTH_BLOCAGE] datetime  NULL,
    [UT_TYPE_BLOCAGE] char(1)  NULL,
    [UT_CHGT_PWD] char(1)  NULL,
    [UT_TD_DROITS] varchar(1992)  NULL,
    [UT_MAX_LOGIN] decimal(5,0)  NULL,
    [UT_NB_LOGIN] decimal(5,0)  NULL,
    [UT_LAST_START] datetime  NULL
);
GO

-- Creating table 'PSITE'
CREATE TABLE [dbo].[PSITE] (
    [PSITE_CD] char(4)  NOT NULL,
    [PSITE_LIB] varchar(100)  NULL,
    [PSITE_ADR1] varchar(150)  NULL,
    [PSITE_ADR2] varchar(150)  NULL,
    [PSITE_ADR3] varchar(100)  NULL,
    [PSITE_CP] char(12)  NULL,
    [PSITE_VILLE] varchar(100)  NULL,
    [PSITE_ROUTAGE] varchar(6)  NULL,
    [PPAYS_CD] varchar(4)  NULL,
    [PDEPART_CD] varchar(4)  NULL,
    [COMMURB_CD] varchar(4)  NULL,
    [REGION_CD] varchar(2)  NULL,
    [PSITE_TEL1] varchar(15)  NULL,
    [PSITE_TEL2] varchar(15)  NULL,
    [PSITE_FAX] varchar(15)  NULL,
    [PSITE_CELL] varchar(15)  NULL,
    [PSITE_PAGER] varchar(15)  NULL,
    [PSITE_EMAIL] varchar(200)  NULL,
    [PSITE_WEB] varchar(80)  NULL,
    [PSITE_CONTACT] varchar(100)  NULL,
    [PSR_CD] varchar(4)  NULL,
    [PET_CD] varchar(4)  NULL,
    [PSITE_NOTES] varchar(255)  NULL
);
GO

-- Creating table 'PERSONNELPSITE'
CREATE TABLE [dbo].[PERSONNELPSITE] (
    [PERSONNEL_PERS_CD] char(10)  NOT NULL,
    [PSITE_PSITE_CD] char(4)  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [PERS_CD] in table 'PERSONNEL'
ALTER TABLE [dbo].[PERSONNEL]
ADD CONSTRAINT [PK_PERSONNEL]
    PRIMARY KEY CLUSTERED ([PERS_CD] ASC);
GO

-- Creating primary key on [UT_CODE] in table 'UTILISATEUR'
ALTER TABLE [dbo].[UTILISATEUR]
ADD CONSTRAINT [PK_UTILISATEUR]
    PRIMARY KEY CLUSTERED ([UT_CODE] ASC);
GO

-- Creating primary key on [PSITE_CD] in table 'PSITE'
ALTER TABLE [dbo].[PSITE]
ADD CONSTRAINT [PK_PSITE]
    PRIMARY KEY CLUSTERED ([PSITE_CD] ASC);
GO

-- Creating primary key on [PERSONNEL_PERS_CD], [PSITE_PSITE_CD] in table 'PERSONNELPSITE'
ALTER TABLE [dbo].[PERSONNELPSITE]
ADD CONSTRAINT [PK_PERSONNELPSITE]
    PRIMARY KEY NONCLUSTERED ([PERSONNEL_PERS_CD], [PSITE_PSITE_CD] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [PERSONNEL_PERS_CD] in table 'PERSONNELPSITE'
ALTER TABLE [dbo].[PERSONNELPSITE]
ADD CONSTRAINT [FK_PERSONNELPSITE_PERSONNEL]
    FOREIGN KEY ([PERSONNEL_PERS_CD])
    REFERENCES [dbo].[PERSONNEL]
        ([PERS_CD])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [PSITE_PSITE_CD] in table 'PERSONNELPSITE'
ALTER TABLE [dbo].[PERSONNELPSITE]
ADD CONSTRAINT [FK_PERSONNELPSITE_PSITE]
    FOREIGN KEY ([PSITE_PSITE_CD])
    REFERENCES [dbo].[PSITE]
        ([PSITE_CD])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PERSONNELPSITE_PSITE'
CREATE INDEX [IX_FK_PERSONNELPSITE_PSITE]
ON [dbo].[PERSONNELPSITE]
    ([PSITE_PSITE_CD]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------