﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Word = Microsoft.Office.Interop.Word;

namespace PhenoReports
{
    class ReportManager
    {
        DataTable consultas;
       private modelHemo.SHIIG_REPORT _currentReportContext;

        public modelHemo.SHIIG_REPORT CurrentReportContext
        {
            get { return _currentReportContext; }
            set { _currentReportContext = value; }
        }

        List<DataTable> resultadosVarios;
        List<string> resultadosUnicos;       


        public ReportManager(modelHemo.SHIIG_REPORT Rep) 
        
        {
            this._currentReportContext = Rep;
        }
        
        public void creaReport()
        {
            consultasReport();           
        
        }

        //TODO: LECTURA DE CONSULTAS INFORME

        private void consultasReport() 
        {
            string nombreDoc="";
            //Recupera la localización del fichero a abrir          
                nombreDoc = _currentReportContext.FILE_LOCATION.ToString().Trim();
Word.Application apWord = new Word.Application();
                try
                {
                    

                    object param = nombreDoc;
                    Word.Document doc = apWord.Documents.Open(ref param);
                    List<Word.Table> tablaWords = new List<Word.Table>();

                    resultadosVarios = new List<DataTable>();
                    var consultasRep = from r1 in _currentReportContext.SHIIG_REPORT_QUERY
                                       select new { r1.ID_REPORT, r1.LIB_QUERY, r1.ID_QUERY, r1.SQL_QUERY, r1.SINGLE_RESULT, r1.SHIIG_REPORT_BOOKMARK };
                    //Por cada consulta genera un dataTable con sus resultados y se guarda el 
                    //identificador de la consulta como el nombre de la tabla
                    foreach (var consulta in consultasRep)
                    {
                        DataTable resultados = QueryUtils.fillDatatableWithSql(consulta.ID_QUERY.ToString(), consulta.SQL_QUERY);

                        //Determina si generar un solo valor en un marcador, una tabla en un marcador o varios valores en 
                        //diferentes marcadores            

                        if (consulta.SINGLE_RESULT.ToString().ToUpper().Equals("T")) //Devuelve 1 Tabla PARA 1 MARCADOR
                        {

                            foreach (var marcadores in consulta.SHIIG_REPORT_BOOKMARK)
                            {
                                tablaWords.Add(apWord.ActiveDocument.Tables.Add(doc.Bookmarks[marcadores.LOCATION.ToString().Trim()].Range, resultados.Rows.Count, resultados.Columns.Count));

                                tablaWords.Last<Word.Table>().Columns.DistributeWidth();
                                tablaWords.Last<Word.Table>().Range.Font.Name = "Courier New";
                                tablaWords.Last<Word.Table>().Borders.Enable = 1;
                                int nfila = 0;
                                int ncol = 1;

                                foreach (DataRow fila in resultados.Rows)
                                {
                                    foreach (Object item in fila.ItemArray)
                                    {
                                        tablaWords.Last<Word.Table>().Cell(nfila, ncol).Range.Text = item.ToString();
                                        ncol++;
                                    }
                                    nfila++;
                                    ncol = 1;
                                }

                            }

                        }
                        else if (consulta.SINGLE_RESULT.ToString().ToUpper().Equals("R")) //Devuelve 1 fila de valores, cada una en un marcador
                        {
                            foreach (var marcadores in consulta.SHIIG_REPORT_BOOKMARK)
                            {
                                if (marcadores.QUERY_FIELD.ToString().Trim().Equals(".")) 
                                {
                                    doc.Bookmarks[marcadores.LOCATION.ToString()].Range.InsertAfter(resultados.Rows[0][0].ToString());
                                }
                                else
                                {
                                    doc.Bookmarks[marcadores.LOCATION.ToString()].Range.InsertAfter(resultados.Rows[0][marcadores.QUERY_FIELD.ToString().Trim()].ToString());
                                }
                            }
                        }
                        resultados.Clear();

                    }
                    
                    
                }
                catch (Exception ex) { System.Windows.MessageBox.Show(ex.Message); }
                finally 
                {
                //Al acabar de rellenar los datos se muestra MS Word
                apWord.Visible = true;
                apWord.PrintPreview = true;
                }
        }

       

    }
}
